#include <pthread.h>
#include <stdio.h>
#define NUM_THREADS     5

long *taskids[NUM_THREADS];

void *PrintHello(void *threadid)
{
  long tid;
  tid = *(long*)threadid;
  printf("Hello World! It's me, thread #%ld!\n", tid);
  pthread_exit(NULL);
}

int main (int argc, char *argv[])
{
  pthread_t threads[NUM_THREADS];
  int rc;
  long t;
  for(t=0; t<NUM_THREADS; t++){
    printf("In main: creating thread %ld\n", t);
    taskids[t] = (long *) malloc(sizeof(long));
    *taskids[t] = t;
    printf("Creating thread %ld\n", t);
    printf ("Taskid = %ld\n", *taskids[t]);
    rc = pthread_create(&threads[t], NULL, PrintHello, (void *) taskids[t]);

    if (rc){
      printf("ERROR; return code from pthread_create() is %d\n", rc);
      exit(-1);
    }
  }
  pthread_exit(NULL);

  for(t=0; t<NUM_THREADS; t++)
    free (taskids[t]);
}
